using PkmnLibSharp.FFI;
using PkmnLibSharp.Utils;
using Interface = PkmnLibSharp.FFI.DynamicData.Libraries.BattleStatCalculator;

namespace PkmnLibSharp.DynamicData.Libraries
{
    public abstract class BattleStatCalculator : ExternPointer<object>
    {
        protected BattleStatCalculator(IdentifiablePointer ptr, bool isOwner) : base(ptr, isOwner){}

        protected override object CreateCache() => new();

        protected override void Destructor() => Interface.battle_stat_calculator_drop(Ptr);
    }

    public class Gen7BattleStatCalculator : BattleStatCalculator
    {
        public Gen7BattleStatCalculator() : base(Interface.gen_7_battle_stat_calculator_new(), true)
        {
        }
    }
}