using System;
using System.Runtime.InteropServices;

namespace PkmnLibSharp.FFI.DynamicData.Libraries
{
    internal static class DamageLibrary
    {
        /// <summary>
        /// Creates a new generation 7 damage library.
        /// </summary>
        /// <param name="hasRandomness">whether or not a random damage modifier (0.85x - 1.00x) is applied to the
        /// calculated damage. 0 for not, 1 for true</param>
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IdentifiablePointer gen_7_damage_library_new(byte hasRandomness);
        
        /// <summary>
        /// Drops a DamageLibrary.
        /// </summary>
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void damage_library_drop(IntPtr ptr);
    }
}