using System;
using System.Runtime.InteropServices;

namespace PkmnLibSharp.FFI.DynamicData.Libraries
{
    internal static class DynamicLibrary
    {
        /// <summary>
        /// Instantiates a new DynamicLibrary with given parameters.
        /// </summary>
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IdentifiablePointer dynamic_library_new(IntPtr staticData, IntPtr statCalculator,
            IntPtr damageLibrary, IntPtr miscLibrary, IntPtr scriptResolver);
        
        /// <summary>
        /// Drops a dynamic library.
        /// </summary>
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void dynamic_library_drop(IntPtr dynamicLibrary);

        /// <summary>
        /// The static data is the immutable storage data for this library.
        /// </summary>
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IdentifiablePointer dynamic_library_get_static_data(IntPtr dynamicLibrary);

    }
}