using System;
using NUnit.Framework;
using PkmnLibSharp.StaticData;

namespace PkmnLibRSharpTests.StaticData
{
    public class AbilityTests
    {
        [Test]
        public void AbilityGetName([Values("foo", "bar", "", "zet", "xy")] string name)
        {
            using var ability = new Ability(name, "", Array.Empty<EffectParameter>());
            Assert.AreEqual(name, ability.Name);
        }

        [Test]
        public void AbilityGetEffect([Values("foo", "bar", "", "zet", "xy")] string effect)
        {
            using var ability = new Ability("", effect, Array.Empty<EffectParameter>());
            Assert.AreEqual(effect, ability.Effect);
        }

        [Test]
        public void AbilityGetParameters()
        {
            using var ability = new Ability("", "",
                new EffectParameter[] { new(100), new(false), new("foobar"), new(true) });
            Assert.AreEqual(4, ability.Parameters.Count);
            var p1 = ability.Parameters[0];
            Assert.AreEqual(100, p1.Data);
            var p2 = ability.Parameters[1];
            Assert.AreEqual(false, p2.Data);
            var p3 = ability.Parameters[2];
            Assert.AreEqual("foobar", p3.Data);
            var p4 = ability.Parameters[3];
            Assert.AreEqual(true, p4.Data);
        }
    }
}