using NUnit.Framework;
using PkmnLibSharp.StaticData.Libraries;

namespace PkmnLibRSharpTests.StaticData.Libraries
{
    public class StaticDataTests
    {
        private PkmnLibSharp.StaticData.Libraries.StaticData Build()
        {
            using var settings = new LibrarySettings(100, 4096);
            using var species = new SpeciesLibrary(0);
            using var moves = new MoveLibrary(0);
            using var items = new ItemLibrary(0);
            using var growthRates = new GrowthRateLibrary(0);
            using var types = new TypeLibrary(0);
            using var natures = new NatureLibrary(0);
            using var abilities = new AbilityLibrary(0);
            return new PkmnLibSharp.StaticData.Libraries.StaticData(settings, species, moves, items,
                growthRates, types, natures, abilities);
        }

        [Test]
        public void CreateNewStaticData()
        {
            using var _ = Build();
        }
        
        [Test]
        public void GetSettings()
        {
            using var library = Build();
            var _ = library.LibrarySettings;
        }

        [Test]
        public void GetSpecies()
        {
            using var library = Build();
            var _ = library.SpeciesLibrary;
        }

        [Test]
        public void GetMoves()
        {
            using var library = Build();
            var _ = library.MoveLibrary;
        }

        [Test]
        public void GetItems()
        {
            using var library = Build();
            var _ = library.ItemLibrary;
        }
        
        [Test]
        public void GetGrowthRates()
        {
            using var library = Build();
            var _ = library.GrowthRateLibrary;
        }

        [Test]
        public void GetTypeLibrary()
        {
            using var library = Build();
            var _ = library.TypeLibrary;
        }
        
        [Test]
        public void GetNatureLibrary()
        {
            using var library = Build();
            var _ = library.NatureLibrary;
        }

        [Test]
        public void GetAbilityLibrary()
        {
            using var library = Build();
            var _ = library.AbilityLibrary;
        }
    }
}